//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    21:55:32 10/09/2012 
// Design Name: 
// Module Name:    top_level 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
`timescale 1ns / 1ps

module ClkOutDDRFF (input SigIn, 
						  output SigOut
						  );

   ODDR2 #( .INIT(1'b0), .SRTYPE("SYNC"), .DDR_ALIGNMENT("NONE"))  
			XLXI_1(		  
                 .C0(SigIn), 
                 .C1(!SigIn),
					  .CE(1'b1), 					  
                 .D0(1'b1), 
                 .D1(1'b0), 
                 .R(1'b0), 
                 .S(1'b0), 
                 .Q(SigOut));
endmodule



module top_level(input MAINCLK1,
					  output PCLKout,
					  output [4:0] Rout,
					  output [5:0] Gout,
					  output [4:0] Bout,
					  output DACBLANKn,
					  output hsync,
					  output vsync
					  );
   
   wire clk108;
   wire hstart;
   wire hblank;
	wire vblank;
   wire countflag;
	wire [15:0] X1;
	wire [15:0] Y1;
	wire [15:0] X;
	wire [15:0] Y;
	wire [9:0] Z;
	
   vga  XLXI_2 (.clk108(clk108),
               .hstart(hstart),
               .vstart(vstart), 	
               .hblank(hblank),
					.vblank(vblank),
               .hsync(hsync),
               .vsync(vsync)
					);
					
   VDACif  XLXI_3 (.clk108(clk108), 
                  .hstart(hstart),
                  .hblank(hblank),
						.vblank(vblank),
						.vsync(vsync),
						.X1(X1),
						.Y1(Y1),
						.Z(Z),
                  .Red_data(Rout[4:0]), 
                  .Green_data(Gout[5:0]), 
                  .Blue_data(Bout[4:0]),
						.DACBLANKn(DACBLANKn),
						.countflag(countflag)
						); 
						
   ClkOutDDRFF  XLXI_4 (.SigIn(clk108), 
                        .SigOut(PCLKout)
								);
								
   clock  XLXI_5 (.CLK_IN1(MAINCLK1), 
                   .CLK_OUT1(clk108)
						 );
						 
	LineGen XLXI_6 (.clk108(clk108),
						 .countflag(countflag),
						 .vblank(vblank),
						 .vsync(vsync),
						 .X(X),
						 .Y(Y)
						 );
						 
	RAMB16_S18_S18 line1XY (
	.CLKA(clk108),
	.ADDRA(Z),
	.DIPA(2'b0),
	.DIA(X),
	.DOA(X1),
	.ENA(!hblank),
	.SSRA(1'b0),	
	.WEA(!hblank),		//always read
	.CLKB(clk108),
	.ADDRB(Z),
	.DIPB(2'b0),
	.DIB(Y),
	.DOB(Y1),
	.ENB(!hblank),
	.SSRB(1'b0),	
	.WEB(!hblank)
	);
	
						 
endmodule